unit informazioni;

interface

uses
  Windows,Messages,SysUtils,Classes,Graphics,Controls,Forms,Dialogs,
  StdCtrls,Buttons,ExtCtrls,Menus;

type
  TInfos=class(TForm)
    Commento:TMemo;
    Label1:TLabel;
    Memo:TMemo;
    Label2:TLabel;
    Fine:TSpeedButton;
    Image1:TImage;
    Image2:TImage;
    Label3:TLabel;
    Label4:TLabel;
    PopupMenu1:TPopupMenu;
    CopybitmaptoClipboard1:TMenuItem;
    PopupMenu2:TPopupMenu;
    CopythebitmaptotheClipboard1:TMenuItem;
    procedure FineClick(Sender:TObject);
    procedure FormOnShow(Sender:TObject);
    //procedure MemoOnEnter(Sender:TObject);
    procedure CopybitmaptoClipboard1Click(Sender:TObject);
    procedure CopythebitmaptotheClipboard1Click(Sender:TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  end;

var
  Infos:TInfos;

implementation
uses gioco24,Clipbrd,Immetti;
{$R *.DFM}

const
 stati:array [0..6] of string[16]=('Failed','Stopped','Best'
       ,'No more sols','More sols','Not used','You didn''t try');

procedure TInfos.FineClick(Sender:TObject);
begin
 if (not gioco24.infogenerali) and (Length(Commento.Text)>0) then
     Strcopy(gioco24.commento,PChar(Commento.Text));
 Close;
end;

procedure TInfos.FormOnShow(Sender:TObject);
 var i,j,temp3,x,y:integer;
     linea:string[16];
     temp2:string[6];
     dati:string[64];
     colore:TColor;
     primavolta:Boolean;
begin
 Memo.Clear;
 if gioco24.infogenerali then
  begin
   Commento.Visible:=False;
   Label1.Visible:=False;
   Memo.Lines.Add('Final Configuration :');
   Image1.Canvas.Font.Name:='Arial';
   Image1.Canvas.Font.Size:=14;
   Image2.Canvas.Font.Name:='Arial';
   Image2.Canvas.Font.Size:=14;
   for i:=0 to 24 do
    begin
     temp3:=gioco24.confinal[i];
     if temp3=0 then temp2:='    |'
      else temp2:=Format('%.2d|',[temp3]);
     j:=i mod 5;
     if (j=0) then linea:=temp2 else linea:=linea+temp2;
     if (j=4) then Memo.Lines.Add(linea);
     if Odd(temp3) then colore:=clRed
      else colore:=clBlue;
     if temp3=0 then colore:=clBlack;
     x:=27*j;
     y:=(i div 5)*27;
     Image1.Canvas.Brush.Color:=colore;
     Image1.Canvas.Rectangle(x,y,x+28,y+28);
     if temp3>0 then//No text for empty space
      begin
       if colore=clRed then Image1.Canvas.Font.Color:=clBlack
        else Image1.Canvas.Font.Color:=clWhite;
       temp2:=IntToStr(temp3);
       //center text
       x:=x+((28-Image1.Canvas.TextWidth(temp2)) div 2);
       y:=y+((28-Image1.Canvas.TextHeight(temp2)) div 2);

       Image1.Canvas.TextOut(x,y,temp2);
      end;
    end;
    Image2.Visible:=False;
   if Clipboard.HasFormat(CF_TEXT) and (Length(Clipboard.AsText)=61) then
    begin
     StrLCopy(@dati[0],@Clipboard.AsText[1],61);
     if StrLComp(@dati[0],'LG24 (Luciani Gianni) Gioco del 24->',36) = 0 then
      begin
       Memo.Lines.Add('Clipboard content :');
       for i:=36 to 60 do
        begin
         temp3:=Ord(dati[i])-65;
         if temp3=0 then temp2:='    |'
          else temp2:=Format('%.2d|',[temp3]);
         j:=(i-1) mod 5;
         if (j=0) then linea:=temp2 else linea:=linea+temp2;
         if (j=4) then Memo.Lines.Add(linea);
         if Odd(temp3) then colore:=clRed
          else colore:=clBlue;
         if temp3=0 then colore:=clBlack;
         x:=27*j;
         y:=((i-36) div 5)*27;
         Image2.Canvas.Brush.Color:=colore;
         Image2.Canvas.Rectangle(x,y,x+28,y+28);
         if temp3>0 then
          begin
           if colore=clRed then Image2.Canvas.Font.Color:=clBlack
            else Image2.Canvas.Font.Color:=clWhite;
           temp2:=IntToStr(temp3);
           x:=x+((28-Image2.Canvas.TextWidth(temp2)) div 2);
           y:=y+((28-Image2.Canvas.TextHeight(temp2)) div 2);
           Image2.Canvas.TextOut(x,y,temp2);
          end;
        end;
      Image2.Visible:=True;
      end else Memo.Lines.Add('Clipboard is empty');
    end else Memo.Lines.Add('Clipboard is empty');
  end
  else
   begin
    Commento.Visible:=True;
    Label1.Visible:=True;
    for i:=0 to 4 do
     begin
      temp3:=gioco24.informazione[i*2];
      if (temp3=Non_Usato) or (temp3=Non_hai_Provato)
          or (temp3=Ha_Fallito) or (temp3=Stato_Fermato)
       then Memo.Lines.Add(Format('%s ->%s',
       [gioco24.nomi[i],stati[temp3]]))
      else Memo.Lines.Add(Format('%s ->%s - Number of sol :%d',
         [gioco24.nomi[i],stati[temp3],informazione[2*i+1]]));
      x:=1;
      j:=solord;
      primavolta:=True;
      while j<>255 do
       begin
        if risposta[j].alg=i then
         begin
          if (i<>4) and primavolta then
           begin
            Memo.Lines.Add('In the listbox');
            primavolta:=False;
           end;
          if i=4 then Memo.Lines.Add(Format('%d) %d moves',
            [x,risposta[j].numosse]))//My solutions don't need time :
            // add it if You Want
          else Memo.Lines.Add(Format('%d) %d moves in %d msec (%d times)',
            [x,risposta[j].numosse,risposta[j].tempo,risposta[j].quante]));
          Inc(x);
         end;
         j:=risposta[j].prossima;
        end;
      j:=solnoninsord;
      primavolta:=True;
      while j<>255 do
       begin
        if risposnonins[j].alg=i then
         begin
          if (i<>4) and primavolta then
           begin
            Memo.Lines.Add('Not in the listbox');
            primavolta:=False;
           end;
          Memo.Lines.Add(Format('%d) %d moves in %d msec (%d times)',
            [x,risposnonins[j].numosse,risposnonins[j].tempo,risposnonins[j].quante]));
          Inc(x);
         end;
        j:=risposnonins[j].prossima;
       end;
      Memo.Lines.Add('--------------------');
     end;
    Commento.Text:=gioco24.commento;
    //Commento.SetFocus;
   end;
end;

{ procedure TInfos.MemoOnEnter(Sender:TObject);
begin
 if not gioco24.infogenerali then Commento.SetFocus;
end; }

procedure TInfos.CopybitmaptoClipboard1Click(Sender:TObject);
begin
 Clipboard.Assign(Image1.Picture);
end;

procedure TInfos.CopythebitmaptotheClipboard1Click(Sender:TObject);
begin
 Clipboard.Assign(Image2.Picture);
end;

procedure TInfos.FormClose(Sender:TObject; var Action:TCloseAction);
begin
 //if Action=caFree then
   if Tag=1 then Form1.Enabled:=True else Form2.Enabled:=True;
end;

end.
